resource "local_file" "inventory" {
  content  = <<-DOC
    # Ansible inventory containing variable values from Terraform.
    # Generated by Terraform.

    [reverse_proxy]
    manzin.ru ansible_host=${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}

    [reverse_proxy:vars]
    domain_name=manzin.ru
    app_internal_ip=${yandex_compute_instance.app.network_interface.0.ip_address}
    monitoring_internal_ip=${yandex_compute_instance.monitoring.network_interface.0.ip_address}
    gitlab_internal_ip=${yandex_compute_instance.gitlab.network_interface.0.ip_address}

    [app]
    app.manzin.ru ansible_host=${yandex_compute_instance.app.network_interface.0.ip_address}

    [app:vars]
    domain_name=app.manzin.ru
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    [mysql_db:children]
    db01
    db02

    [db01]
    db01.manzin.ru ansible_host=${yandex_compute_instance.db01.network_interface.0.ip_address}

    [db01:vars]
    domain_name=db01.manzin.ru
    mysql_server_id=1
    mysql_replication_role=master
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    [db02]
    db02.manzin.ru ansible_host=${yandex_compute_instance.db02.network_interface.0.ip_address}

    [db02:vars]
    domain_name=db02.manzin.ru
    mysql_server_id=2
    mysql_replication_role=slave
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    [gitlab]
    gitlab.manzin.ru ansible_host=${yandex_compute_instance.gitlab.network_interface.0.ip_address}

    [gitlab:vars]
    domain_name=gitlab.manzin.ru
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    [runner]
    runner.manzin.ru ansible_host=${yandex_compute_instance.runner.network_interface.0.ip_address}

    [runner:vars]
    domain_name=runner.manzin.ru
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    [monitoring]
    monitoring.manzin.ru ansible_host=${yandex_compute_instance.monitoring.network_interface.0.ip_address}

    [monitoring:vars]
    domain_name=monitoring.manzin.ru
    ansible_ssh_common_args='-o ProxyCommand="ssh -W %h:%p -q aleksandr@${yandex_vpc_address.vpc_address.external_ipv4_address[0].address}"'

    DOC
  filename = "../ansible/inventory"

  depends_on = [
    yandex_compute_instance.reverse_proxy,
    yandex_compute_instance.app,
    yandex_compute_instance.db01,
    yandex_compute_instance.db02,
    yandex_compute_instance.gitlab,
    yandex_compute_instance.runner,
    yandex_compute_instance.monitoring
  ]
}
